#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "affichage_cours.h"

void retour_cours()
{
	int i = 0 , j = 0;
	
	for(i = 50 ; i < 59 ; i++)for(j = 49 ; j < 78 ; j++)ML_pixel(j,i,ML_XOR);
}

void bouton_retour(int x, int y)
{
	ML_line(x,y,x,y+10,ML_BLACK);
	ML_line(x,y,x+30,y,ML_BLACK);
	ML_line(x+30,y,x+30,y+10,ML_BLACK);
	ML_line(x,y+10,x+31,y+10,ML_BLACK);
	
	PrintMini(x+4,y+3,"Retour",0);
}

void bouton_retour_cours()
{
	int i;
	
	ML_line(115,53,115,61,ML_BLACK);		//Dessin du carre entourant la fleche
	ML_line(125,53,125,61,ML_BLACK);
	ML_line(115,53,125,53,ML_BLACK);	
	ML_line(115,61,126,61,ML_BLACK);

	ML_line(117,57,124,57,ML_BLACK);		//Dessin de la fleche
	ML_line(118,56,124,56,ML_BLACK);
	ML_line(118,58,124,58,ML_BLACK);
	ML_pixel(119,55,ML_BLACK);
	ML_pixel(119,59,ML_BLACK);
	
}

void affichage_bouton_retour_cours()
{
	int i = 0 , j = 0;
	
	for(i = 116 ; i < 125 ; i++)for(j = 54 ; j < 61 ; j++)ML_pixel(i,j,ML_XOR);
}

void cours_pixel(int a)		//Dessin des pixel symbolisant les pages dans chaque parties du cours
{
	int i = 0;
	
	for(i = (64-(7*(a-1))) ; i < (63+6*a) ; i+= 13)ML_pixel(i,56,ML_BLACK);

}

void choix_cours(int choix , int total)		//total : nombre total de cours pour le chapitre considere
{
	int x = 0 , y = 23;

	switch(total)
	{
		case 3 :
			x =32*(choix-1) + 29;
			break;

		case 4 :
			x =24*(choix-1) + 24;
			break;
		
		case 5 :
			x =21*(choix-1) + 19;
			break;

		case 6 :
			x =18*(choix-1) + 16;
			break;
	
		case 7 :
			x =16*(choix-1) + 13;
			break;
		
		case 8 :
			x =14*(choix-1) + 13;
			break;
		
		case 9 :
			x =13*(choix-1) + 9;
			break;
		
		default :
			x =13*(choix-1) + 9;
			break;
	}
	
	affichage_carre(x,y);
	
}

void choix_page(int choix , int total)		//total : nombre total de pages pour la partie du cours consideree
{
	int x = (13*(choix-1) + 2), y = 54;
	
	switch(total)
	{
		case 1 :			//pour une page
			x+=60;
			break;
		
		case 2 :			//pour deux pages
			x+=53;
			break;
	
		case 3 :
			x+=46;
			break;
	
		case 4 :
			x+=39;
			break;
	
		case 5 :			
			x+=32;
			break;
			
		case 6 :			
			x+=25;
			break;
		
		case 7:
			x+=18;
			break;	
	}
	
	affichage_carre(x,y);
}
	
void affichage_carre(int x, int y)
{
	ML_pixel(x+2,y+2,ML_BLACK);	//affichage ou effaage du carr noir
	ML_pixel(x,y,ML_XOR);
	ML_line(x,y,x+4,y,ML_XOR);
	ML_line(x+4,y,x+4,y+4,ML_XOR);
	ML_line(x,y,x,y+4,ML_XOR);
	ML_line(x,y+4,x+5,y+4,ML_XOR);
}

void affichage_menu_cours(int total, int a)		//total de differentes sections dans le cours
{
	int i = 0;
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);		//Dessin de la bande noire
	
	switch(total)	//pixels
	{
		
		case 3 :
			for(i = 31 ; i < 106 ; i+=32)	
			ML_pixel(i,25,ML_BLACK);
			break;

		case 4 :
			for(i = 26 ; i < 106 ; i+=24)ML_pixel(i,25,ML_BLACK);
			break;
		
		case 5 :
			for(i = 21 ; i < 106 ; i+=21)ML_pixel(i,25,ML_BLACK);
			break;
	
		case 6 :
			for(i = 18 ; i < 110 ; i+=18)ML_pixel(i,25,ML_BLACK);
			break;
		
		case 7 :
			for(i = 15 ; i < 120 ; i+=16)ML_pixel(i,25,ML_BLACK);
			break;
		
		case 8 :
			for(i = 15 ; i < 127 ; i+=14)ML_pixel(i,25,ML_BLACK);
			break;
	
		case 9 :
			for(i = 11 ; i < 120 ; i += 13)ML_pixel(i,25,ML_BLACK);
			break;
	
		default :
			for(i = 21 ; i < 106 ; i+=21)ML_pixel(i,25,ML_BLACK);
			break;
	}
	
	choix_cours(a,total);
	
	bouton_retour(48,49);
}

void affichage_menu_choix_cours_complexe(int a)	//a : 0 si on efface juste le bas, 1 si on efface tout
{
	int i = 0;
		
	if(a)
		clear();
	else
		for(i  = 20 ; i < 63 ; i++)ML_line(1,i,127,i,ML_WHITE);
	
	bouton_retour(48,49);
				
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,1);

	PrintXY(37,6,"Complexes",1);
				
	for(i = 0 ; i < 58 ; i +=57)
	{
		ML_line(12+i,26,57+i,26,ML_BLACK);
		ML_line(12+i,26,12+i,40,ML_BLACK);
		ML_line(12+i,40,58+i,40,ML_BLACK);
		ML_line(57+i,26,57+i,40,ML_BLACK);
	}
				
	PrintMini(17,31,"Complexes",1);
	PrintMini(73,31,"Arguments",1);
				
	
}

void affichage_complexe_choix_cours(int a)
{
	int i = 0;
	
	if(a == 1 || a == 2)for(i = 13 +57*(a-1) ; i < 57+57*(a-1) ; i++)ML_line(i,27,i,40,ML_XOR);
	
	if(a == 3)retour_cours();
	
}

void affichage_menu_choix_cours_integration(int a)	//a : 0 si on efface juste le bas, 1 si on efface tout
{
	int i = 0;
		
	if(a)
		clear();
	else
		for(i  = 20 ; i < 63 ; i++)ML_line(1,i,127,i,ML_WHITE);
	
	bouton_retour(48,49);
				
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,1);

	PrintXY(31,6,"Integration",1);	
				
	for(i = 0 ; i < 58 ; i +=57) 	//Affichage deux cases
	{
		ML_line(11+i,26,58+i,26,ML_BLACK);
		ML_line(11+i,26,11+i,40,ML_BLACK);
		ML_line(11+i,40,59+i,40,ML_BLACK);
		ML_line(58+i,26,58+i,40,ML_BLACK);
	}
				
	PrintMini(13,31,"Integration",1);
	PrintMini(74,31,"Primitives",1);
				
	
}

void affichage_integration_choix_cours(int a)
{
	int i = 0;
	
	if(a == 1 || a == 2)for(i = 12 +57*(a-1) ; i < 58+57*(a-1) ; i++)ML_line(i,27,i,40,ML_XOR);
	
	if(a == 3)retour_cours();
	
}