#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "affichage_signes.h"

void infini(int x, int y)		//Dessin du symbole infini
{
	ML_line(x,y+1,x,y+3,ML_BLACK);
	ML_line(x+1,y,x+4,y,ML_BLACK);
	ML_line(x+1,y+3,x+4,y+3,ML_BLACK);
	ML_line(x+4,y+1,x+4,y+3,ML_BLACK);
	ML_line(x+5,y,x+8,y,ML_BLACK);
	ML_line(x+5,y+3,x+8,y+3,ML_BLACK);
	ML_line(x+8,y+1,x+8,y+3,ML_BLACK);
}

void signe_superieur_egal(int x, int y)
{
	ML_line(x,y,x+3,y+3,ML_BLACK);
	ML_line(x,y+3,x+4,y+3,ML_BLACK);
	ML_line(x,y+5,x+4,y+5,ML_BLACK);
}

void signe_inferieur_egal(int x, int y)
{
	ML_line(x+3,y,x,y+3,ML_BLACK);
	ML_line(x,y+3,x+4,y+3,ML_BLACK);
	ML_line(x,y+5,x+4,y+5,ML_BLACK);
}

void equivaut(int x, int y)
{
	int i = 0;
	
	for(i = 0 ; i < 3 ; i++)
	{
		ML_pixel(x+i,y+2-i,ML_BLACK);
		ML_pixel(x+i,y+2+i,ML_BLACK);
	}
	
	ML_line(x+3,y+1,x+6,y+1,ML_BLACK);
	ML_line(x+3,y+3,x+6,y+3,ML_BLACK);
	
	for(i = 0 ; i < 3 ; i++)
	{
		ML_pixel(x+8-i,y+2-i,ML_BLACK);
		ML_pixel(x+8-i,y+2+i,ML_BLACK);
	}
	
}

void comp(int x, int y)		//Signe des nombres complexes
{
	PrintMini(x+2,y,"C",1);
	ML_line(x+3,y,x+3,y+4,ML_BLACK);
}

void affichage_limite(int x, int y, int tend , int egalite)		//(x,y) : coordonnees, tend : x tend vers cette valeur (+infini si c'est 100 et -infini si c'est -100), egalite : si c'est 0 : pas d'incidence, si c'est 1 , superieur, si c'est -1 : inferieur
{
	if(tend == 100 || tend == -100)
		egalite = 0;
	
	PrintMini(x,y,"lim",1);
	PrintMini(x,y+6,"x",1);
	ML_line(x+4,y+8,x+9,y+8,ML_BLACK);
	ML_line(x+7,y+7,x+7,y+10,ML_BLACK);
	
	if(!tend)PrintMini(x+10,y+6,"0",1);
	
	if(tend == 20)PrintMini(x+10,y+6,"a",1);
	
	if(tend == 1)PrintMini(x+10,y+6,"1",1);
	
	if(tend == 2)PrintMini(x+10,y+6,"2",1);
	
	if(tend == 100)
	{
		PrintMini(x+10,y+6,"+",1);
		infini(x+15,y+7);
	}
	
	if(tend == -100)
	{
		PrintMini(x+10,y+6,"-",1);
		infini(x+15,y+7);
	}
	
	if(egalite != 0)
	{
		PrintMini(x,y+12,"x",1);
		
		if(egalite == -1)
			PrintMini(x+5,y+12,"<",1);
		else
			PrintMini(x+5,y+12,">",1);
	
		if(!tend)PrintMini(x+10,y+12,"0",1);
		if(tend)PrintMini(x+10,y+12,"1",1);
	}
	
}

void different(int x, int y)	//Signe different
{
	ML_line(x,y+1,x+5,y+1,ML_BLACK);
	ML_line(x,y+3,x+5,y+3,ML_BLACK);
	ML_line(x+1,y+4,x+4,y-1,ML_BLACK);
}

void inter(int x, int y)		//Signe inter (pour les probabilites)
{
	ML_line(x,y,x,y+5,ML_BLACK);
	ML_line(x+2,y,x+2,y+5,ML_BLACK);
	ML_line(x,y,x+2,y,ML_BLACK);
}

void somme(int x, int y)		//Signe somme
{
	ML_line(x,y,x+8,y,ML_BLACK);
	ML_line(x,y+8,x+8,y+8,ML_BLACK);
	ML_line(x,y,x+4,y+4,ML_BLACK);
	ML_line(x+4,y+4,x,y+8,ML_BLACK);
}

void parenthese(int x, int y, int longueur)		//dessin grandes parentheses
{
	ML_line(x,y+3,x+3,y,ML_BLACK);		//Premiere parenthese
	ML_line(x,y+3,x,y+13,ML_BLACK);
	ML_line(x,y+13,x+3,y+16,ML_BLACK);

	ML_line(x+longueur+1,y+1,x+3+longueur,y+3,ML_BLACK);		//Deuxieme parenthese
	ML_line(x+3+longueur,y+3,x+3+longueur,y+13,ML_BLACK);
	ML_line(x+longueur+3,y+13,x+longueur,y+16,ML_BLACK);
}

void racine_carre(int x, int y, int longueur)		//Dessin racine carree
{
	ML_line(x,y+5,x+2,y+7,ML_BLACK);
	ML_line(x+2,y+7,x+3,y,ML_BLACK);
	ML_line(x+3,y,x+3+longueur,y,ML_BLACK);
}

void delta(int x, int y)	//Dessin delta
{
	ML_line(x,y+4,x+7,y+4,ML_BLACK);
	ML_line(x,y+4,x+3,y+1,ML_BLACK);
	ML_line(x+3,y+1,x+6,y+4,ML_BLACK);
}

void theta(int x, int y)	//Dessin theta
{
	ML_line(x,y,x,y+4,ML_BLACK);
	ML_line(x+1,y-1,x+3,y-1,ML_BLACK);
	ML_line(x+3,y,x+3,y+4,ML_BLACK);
	ML_line(x+1,y+4,x+3,y+4,ML_BLACK);
	ML_line(x,y+1,x+3,y+1,ML_BLACK);
}

void pi(int x, int y)		//Dessin pi
{
	ML_line(x+1,y+1,x+1,y+5,ML_BLACK);
	ML_line(x+3,y+1,x+3,y+5,ML_BLACK);
	ML_line(x,y,x+5,y,ML_BLACK);
}

void modulo_deux_pi(int x, int y)	//Dessin modulo 2pi
{
	PrintMini(x,y,"[2",1);
	pi(x+7,y);
	PrintMini(x+13,y,"]",1);
}

void signe_int(int x, int y, int variables)		//Dessin signe integration
{
	ML_line(x+1,y+1,x+1,y+13,ML_BLACK);	//Dessin signe de l'integration
	ML_pixel(x+2,y,ML_BLACK);
	ML_pixel(x+3,y+1,ML_BLACK);
	ML_pixel(x,y+13,ML_BLACK);
	ML_pixel(x-1,y+12,ML_BLACK);
	
	switch(variables)
	{
		case 1:
			PrintMini(x+5,y,"b",1);
			PrintMini(x+3,y+9,"a",1);
			break;
			
		case 2:
			PrintMini(x+4,y,"a",1);
			PrintMini(x+3,y+9,"b",1);
			break;
			
		case 3:
			PrintMini(x+5,y,"c",1);
			PrintMini(x+3,y+9,"a",1);
			break;
			
		case 4:
			PrintMini(x+5,y,"b",1);
			PrintMini(x+3,y+9,"c",1);
			break;
			
		case 5:
			PrintMini(x+4,y,"1",1);
			PrintMini(x+3,y+9,"0",1);
			break;
		
		case 6:
			PrintMini(x+3,y+9,"I",1);
			break;
			
		case 7:
			PrintMini(x+3,y+9,"J",1);
			break;
			
		case 8:
			PrintMini(x+5,y,"e",1);
			PrintMini(x+2,y+9,"1",1);
			break;
	}

}

void congru(int x, int y)
{	
	int i = 0;
	
	for(i = 0 ; i < 5 ; i += 2)ML_line(x,y+i,x+5,y+i,ML_BLACK);
}

void lambda(int x, int y)
{
	ML_line(x,y,x+6,y+6,ML_BLACK);
	ML_line(x+1,y,x+7,y+6,ML_BLACK);
	ML_pixel(x,y+5,ML_BLACK);
	ML_line(x+2,y+2,x,y+6,ML_BLACK);
	ML_line(x+3,y+3,x,y+6,ML_BLACK);
}

void lambda_cours(int x, int y)
{
	ML_line(x+1,y,x+6,y+5,ML_BLACK);
	ML_line(x+3,y+2,x,y+5,ML_BLACK);
}

void appartient(int x, int y)
{
	int i = 0;
	
	ML_line(x,y+1,x,y+4,ML_BLACK);
	for(i = 0 ; i < 5 ; i += 2)ML_line(x+1,y+i,x+4,y+i,ML_BLACK);
}
