#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void geometrie()	
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	//Affichage du menu des suites
	
	PrintXY(36,6,"Geometrie",1);	
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				geometrie_cours();
	
			if(choix == 2)
				geometrie_question();
		
			clear();
			
			menu_cours(choix);
			PrintXY(36,6,"Geometrie",1);	

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	

	}

	
}

void geometrie_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(9,1);
	
	PrintXY(12,6,"Geometrie : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 9  && position == 1)
		{
			choix += 1;
			choix_cours(choix,9);
			choix_cours(choix-1,9);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,9);
			choix_cours(choix+1,9);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,9);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,9);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(33,34,"Droites et plans",0);
						break;
					case 2:
						PrintMini(40,34,"Parallelisme",0);
						break;
					case 3:
						PrintMini(37,34,"Orthogonalite",0);
						break;
					case 4:
						PrintMini(20,34,"Geometrie vectorielle",0);
						break;
					case 5:
						PrintMini(48,34,"Reperage",0);
						break;
					case 6:
						PrintMini(33,34,"Produit scalaire",0);
						break;
					case 7:
						PrintMini(28,34,"Equation d'un plan",0);
						break;
					case 8:
						PrintMini(7,34,"Representation parametriques",0);
						break;
					case 9:
						PrintMini(23,34,"Equation d'une sphere",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 4;		//Nombre de pages predominant
			
			switch(choix)		//Affichage nom de la partie et determination du nombre de pages
			{
				case 1:
					PrintMini(33,4,"Droites et plans",0);
					break;
				case 2:
					PrintMini(40,4,"Parallelisme",0);
					pages = 5;
					break;
				case 3:
					PrintMini(37,4,"Orthogonalite",0);
					pages = 5;
					break;
				case 4:
					PrintMini(20,4,"Geometrie vectorielle",0);
					pages = 3;
					break;
				case 5:
					PrintMini(48,4,"Reperage",0);
					pages = 1;
					break;
				case 6:
					PrintMini(33,4,"Produit scalaire",0);
					break;
				case 7:
					PrintMini(28,4,"Equation d'un plan",0);
					pages = 3;
					break;
				case 8:
					PrintMini(23,4,"Representation para.",0);
					break;
				case 9:
					PrintMini(23,4,"Equation d'une sphere",0);
					pages = 1;
					break;
			}
			
			if(choix == 4 || choix > 7)
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,11+116*j,i,ML_BLACK);
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 14 ; i <51 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Par trois points A, B et C non",1);
									PrintMini(4,26,"alignes passe un seul plan",1);
									PrintMini(4,34,"note (ABC)",1);
									break;
									
								case 2:
									PrintMini(4,18,"Si d est une droite et A un",1);
									PrintMini(4,26,"point n'appartenant pas a d",1);
									PrintMini(4,34,"alors il existe un seul plan",1);
									PrintMini(4,42,"contenant A et d",1);
									break;
									
								case 3:
									PrintMini(4,18,"Si deux droites distinctes sont",1);
									PrintMini(4,26,"strictement paralleles ou",1);
									PrintMini(4,34,"secantes, alors il existe un",1);
									PrintMini(4,42,"seul plan les contenant",1);
									break;
									
								case 4:
									PrintMini(4,18,"Si deux plans sont secants,",1);
									PrintMini(4,26,"alors leur intersection est",1);
									PrintMini(4,34,"une droite",1);
									break;
									
								case 5:	
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Deux droites sont coplanaires",1);
									PrintMini(4,26,"si elles sont contenues dans",1);
									PrintMini(4,34,"le meme plan",1);
									break;
								
								case 2:
									PrintMini(4,18,"Deux droites sont paralleles",1);
									PrintMini(4,26,"si elles sont coplanaires et ",1);
									PrintMini(4,34,"qu'elles n'ont pas de points",1);
									PrintMini(4,42,"en communs (ou confondues)",1);
									break;
									
								case 3:
									PrintMini(4,18,"Deux plans sont paralleles",1);
									PrintMini(4,26,"s'ils n'ont pas de points en ",1);
									PrintMini(4,34,"communs ou s'ils sont",1);
									PrintMini(4,42,"confondus",1);
									break;
								
								case 4:
									PrintMini(4,18,"Une droite et un plan sont",1);
									PrintMini(4,26,"paralleles s'ils n'ont pas de",1);
									PrintMini(4,34,"points en communs ou s'ils",1);
									PrintMini(4,42,"sont confondus",1);
									break;	
									
								case 5:
									PrintMini(4,18,"Si une droite est parallele",1);
									PrintMini(4,26,"a deux plans secants, alors",1);
									PrintMini(4,34,"elle est parallele a leur",1);
									PrintMini(4,42,"intersection",1);
									break;	
																																											
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Deux plans sont orthogonaux",1);
									PrintMini(4,26,"(ou perpendiculaire) si l'un",1);
									PrintMini(4,34,"deux contient une droite",1);
									PrintMini(4,42,"orthogonale a l'autre",1);
									break;
								
								case 2:
									PrintMini(4,18,"Le projete orthogonal de M",1);
									PrintMini(4,26,"sur un plan est l'intersection",1);
									PrintMini(4,34,"de ce plan avec la ",1);
									PrintMini(4,42,"perpendiculaire passant par M",1);
									break;
									
								case 3:
									PrintMini(3,18,"Le plan mediateur du segment",1);
									PrintMini(3,26,"[AB] est le plan passant par",1);
									PrintMini(3,34,"le milieu du segment et qui est",1);
									PrintMini(3,42,"perpendiculaire a la droite (AB)",1);
									break;
							
								case 4:
									PrintMini(4,18,"Un point M appartient au plan",1);
									PrintMini(4,26,"mediateur d'un segment si",1);
									PrintMini(4,34,"M est equidistant de A et de B",1);
									PrintMini(4,42,"MA = MB",1);
									break;
								
								case 5:
									PrintMini(4,18,"Une droite est perpendiculaire",1);
									PrintMini(4,26,"a un plan si elle est",1);
									PrintMini(4,34,"orthogonale a deux droite",1);
									PrintMini(4,42,"secantes de ce plan",1);
									break;
									
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Un point A de l'espace et deux",1);
									PrintMini(4,26,"vecteurs non colineaires",1);
									PrintMini(4,35,"u et v definissent un plan P",1);
									ML_line(4,33,8,33,ML_BLACK);
									ML_line(24,33,28,33,ML_BLACK);
									ML_line(6,32,6,35,ML_BLACK);
									ML_line(26,32,26,35,ML_BLACK);
									break;
								
								case 2:
									PrintMini(4,18,"Le plan P est l'ensemble des",1);
									PrintMini(4,26,"points M de l'espace tel",1);
									PrintMini(4,34,"qu'il existe des reels x et y :",1);
									PrintMini(4,43,"AM = xu + yv",1);
									ML_line(4,41,13,41,ML_BLACK);
									ML_line(11,40,11,43,ML_BLACK);
									ML_line(29,41,33,41,ML_BLACK);
									ML_line(50,41,54,41,ML_BLACK);
									ML_line(31,40,31,43,ML_BLACK);
									ML_line(52,40,52,43,ML_BLACK);
									break;
									
								case 3:
									PrintMini(4,18,"Soient des vecteurs u, v et w",1);
									ML_line(84,16,88,16,ML_BLACK);
									ML_line(86,15,86,18,ML_BLACK);
									ML_line(95,16,99,16,ML_BLACK);
									ML_line(97,15,97,18,ML_BLACK);
									ML_line(115,16,120,16,ML_BLACK);
									ML_line(118,15,118,18,ML_BLACK);
									PrintMini(4,27,"tel que u et v ne sont pas",1);
									ML_line(36,25,40,25,ML_BLACK);
									ML_line(38,24,38,27,ML_BLACK);
									ML_line(56,25,60,25,ML_BLACK);
									ML_line(58,24,58,27,ML_BLACK);
									PrintMini(4,35,"colineaire : Ces vecteurs sont",1);
									PrintMini(4,44,"coplanaires si w = au + bv",1);
									ML_line(62,42,67,42,ML_BLACK);
									ML_line(65,41,65,44,ML_BLACK);
									ML_line(84,42,88,42,ML_BLACK);
									ML_line(86,41,86,44,ML_BLACK);
									ML_line(104,42,108,42,ML_BLACK);
									ML_line(106,41,106,44,ML_BLACK);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Soit (O , i , j , k) un repere",1);
									ML_line(39,16,43,16,ML_BLACK);
									ML_line(41,15,41,18,ML_BLACK);
									ML_line(53,15,57,15,ML_BLACK);
									ML_line(55,14,55,17,ML_BLACK);
									ML_line(67,15,71,15,ML_BLACK);
									ML_line(69,14,69,17,ML_BLACK);
									PrintMini(4,26,"de l'espace : pour tout point",1);
									PrintMini(4,34,"M de l'espace on a :",1);
									PrintMini(4,44,"OM = xi + yj + zk",1);
									ML_line(29,42,33,42,ML_BLACK);
									ML_line(31,41,31,44,ML_BLACK);
									ML_line(48,41,52,41,ML_BLACK);
									ML_line(50,40,50,43,ML_BLACK);
									ML_line(67,41,71,41,ML_BLACK);
									ML_line(69,40,69,43,ML_BLACK);
									ML_line(4,42,13,42,ML_BLACK);
									ML_line(11,41,11,44,ML_BLACK);
									break;
									
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 6:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,17,"La norme d'un vecteur est sa",1);
									PrintMini(4,26,"longueur. La norme de u",1);
									ML_line(98,24,102,24,ML_BLACK);
									ML_line(100,23,100,26,ML_BLACK);
									PrintMini(4,34,"(de coordonnees (x,y,z)) est :",1);
									PrintMini(4,44,"||u|| = ",1);
									ML_line(8,42,12,42,ML_BLACK);
									ML_line(10,41,10,44,ML_BLACK);
									racine_carre(25,42,52);
									PrintMini(31,46,"x  + y  + z",1);
									PrintMini(35,44,"2    2    2",1);
									break;
								
								case 2:
									PrintMini(4,18,"On appelle produit scalaire",1);
									ML_line(57,25,61,25,ML_BLACK);
									ML_line(59,24,59,27,ML_BLACK);
									ML_line(77,25,81,25,ML_BLACK);
									ML_line(79,24,79,27,ML_BLACK);
									PrintMini(4,27,"des vecteurs u et v le reel :",1);
									PrintMini(4,38,"u.v =   (||u|| +||v|| -||u-v|| )",1);
									ML_line(28,40,32,40,ML_BLACK);
									PrintMini(28,34,"1",1);
									PrintMini(28,42,"2",1);
									PrintMini(51,35,"2",1);
									PrintMini(71,35,"2",1);
									PrintMini(99,35,"2",1);
									ML_line(4,36,8,36,ML_BLACK);
									ML_line(6,35,6,38,ML_BLACK);
									ML_line(12,36,16,36,ML_BLACK);
									ML_line(14,35,14,38,ML_BLACK);
									ML_line(43,36,47,36,ML_BLACK);
									ML_line(45,35,45,38,ML_BLACK);
									ML_line(63,36,67,36,ML_BLACK);
									ML_line(65,35,65,38,ML_BLACK);
									ML_line(83,36,87,36,ML_BLACK);
									ML_line(85,35,85,38,ML_BLACK);
									ML_line(91,36,95,36,ML_BLACK);
									ML_line(93,35,93,38,ML_BLACK);
									break;
								
								case 3:
									PrintMini(4,18,"u.v = ||u|| * ||v|| * cos(u,v)",1);
									ML_line(4,16,8,16,ML_BLACK);
									ML_line(6,15,6,18,ML_BLACK);
									ML_line(12,16,16,16,ML_BLACK);
									ML_line(14,15,14,18,ML_BLACK);
									ML_line(32,16,36,16,ML_BLACK);
									ML_line(34,15,34,18,ML_BLACK);
									ML_line(58,16,62,16,ML_BLACK);
									ML_line(60,15,60,18,ML_BLACK);
									ML_line(95,16,99,16,ML_BLACK);
									ML_line(97,15,97,18,ML_BLACK);
									ML_line(102,16,106,16,ML_BLACK);
									ML_line(104,15,104,18,ML_BLACK);
									PrintMini(4,28,"Si u(a,b,c) et v(a',b',c') :",1);
									PrintMini(4,38,"u.v = aa' + bb' + cc'",1);
									ML_line(4,36,8,36,ML_BLACK);
									ML_line(6,35,6,38,ML_BLACK);
									ML_line(12,36,16,36,ML_BLACK);
									ML_line(14,35,14,38,ML_BLACK);
									break;
									
								case 4:
									PrintMini(4,18,"Si les vecteurs u et v sont",1);
									ML_line(67,16,71,16,ML_BLACK);
									ML_line(69,15,69,18,ML_BLACK);
									ML_line(87,16,91,16,ML_BLACK);
									ML_line(89,15,89,18,ML_BLACK);
									PrintMini(4,26,"perpendiculaires, alors leur",1);
									PrintMini(4,34,"produit scalaire est egal a 0",1);
									break;
									
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 7:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Soit P un plan de l'espace",1);
									PrintMini(4,26,"On appelle vecteur normal a",1);
									PrintMini(4,34,"P tout vecteur directeur d'une",1);
									PrintMini(4,42,"droite perpendiculaire a P",1);
									break;
								
								case 2:
									PrintMini(4,18,"Soit n(a,b,c) un vecteur non",1);
									PrintMini(4,26,"nul : les plans de vecteur",1);
									ML_line(22,16,26,16,ML_BLACK);
									ML_line(24,15,24,18,ML_BLACK);
									PrintMini(4,35,"normal n ont pour equation",1);
									ML_line(36,33,40,33,ML_BLACK);
									ML_line(38,32,38,35,ML_BLACK);
									PrintMini(4,43,"cartesienne ax+by+cz+d=0",1);
									break;
								
								case 3:
									PrintMini(4,18,"Pour determiner d, il faut",1);
									PrintMini(4,26,"resoudre l'equation avec",1);
									PrintMini(4,34,"un point situe sur le plan",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 8:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"La droite passant par le point",1);
									PrintMini(4,26,"A(xa,ya,za) et de vecteur",1);
									PrintMini(4,35,"directeur u(a,b,c) a pour",1);
									ML_line(44,33,48,33,ML_BLACK);
									ML_line(46,32,46,35,ML_BLACK);
									PrintMini(4,43,"equation parametrique :",1);
									break;
								
								case 2:
									PrintMini(4,18,"x = xa + a*t",1);
									PrintMini(4,26,"y = ya + b*t",1);
									PrintMini(4,34,"z = za + c*t",1);
									PrintMini(4,42,"avec t un reel",1);
									break;
									
								case 3:
									PrintMini(4,18,"Le plan passant par le point",1);
									PrintMini(4,26,"A et de vecteurs directeur",1);
									PrintMini(4,35,"u(a,b,c) et v(d,e,f) a pour",1);
									ML_line(4,33,8,33,ML_BLACK);
									ML_line(6,32,6,35,ML_BLACK);
									ML_line(48,33,52,33,ML_BLACK);
									ML_line(50,32,50,35,ML_BLACK);
									PrintMini(4,43,"equation parametrique :",1);
									break;
								
								case 4:
									PrintMini(4,18,"x = xa + a*t + d*t'",1);
									PrintMini(4,26,"y = ya + b*t + e*t'",1);
									PrintMini(4,34,"z = za + c*t + f*t'",1);
									PrintMini(4,42,"avec t et t' des reels",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 9:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"L'equation cartesienne d'une",1);
									PrintMini(4,26,"sphere de centre A(a,b,c) et",1);
									PrintMini(4,34,"de rayon r est :",1);
									PrintMini(4,42,"(x-a)  + (y-b)  + (z-c)  = r",1);
									PrintMini(22,40,"2                2",1);
									PrintMini(56,40,"2",1);
									PrintMini(111,40,"2",1);
									break;
									
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
	
			affichage_menu_cours(9,choix);
			PrintXY(12,6,"Geometrie : cours",1);
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void geometrie_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0, fleche = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour, fleche : si c'est egal a 1 : regarde s'il faut afficher ou non une fleche
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(10,6,"Geometrie : quest.",1);
	
	question();
	
	case_question_geometrie(2);
	case_question(1,2);

	fleche_question(milieu,8);
	
	affichage_question_geometrie(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 9 && retour == 0)
		{
			choix ++;
			
			if(choix > (milieu + 1))
			{	
				milieu ++;
				fleche = 1;		
				case_question_geometrie(milieu);
				
			}
			else
				case_question(choix - 1 , milieu);
			
			case_question(choix,milieu);	
			affichage_question_geometrie(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			if(choix < (milieu - 1))
			{	
				milieu --;
				fleche = 1;
				case_question_geometrie(milieu);
				case_question(choix,milieu);
			}
			else
			{
				case_question(choix + 1 , milieu);
				case_question(choix , milieu);
			}
	
			affichage_question_geometrie(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(fleche)	//Affichage des fleches pour que l'utilisateur sache s'il y a des choix plus bas ou plus haut
		{
			fleche_question(milieu,8);
			fleche = 0;	
		}

		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			pages = 3;		//nombre de page predominante	
			
			switch(choix)
			{
				case 1:
					PrintMini(39,4,"Points et plans",1);
					break;
				case 2:
					PrintMini(39,4,"Equation parametrique",1);
					break;
				case 3:
					PrintMini(39,4,"Relation droites",1);
					break;
				case 4:
					PrintMini(39,4,"Relation plans",1);
					break;
				case 5:
					pages = 4;
					PrintMini(39,4,"Relation droite/plan",1);
					break;
				case 6:
					pages = 4;
					PrintMini(39,4,"Point intersection",1);
					break;
				case 7:
					pages = 5;
					PrintMini(39,4,"Projete orthogonal",1);
					break;
				case 8:
					pages = 2;
					PrintMini(39,4,"Type de figure",1);
					break;
				case 9:
					pages = 2;
					PrintMini(39,4,"Section d'une figure",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <53 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Trois points definissent un",1);
									PrintMini(4,22,"plan si et seulement s'ils ne",1);
									PrintMini(4,30,"sont pas alignes",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : On a A(0,0,0) B(3,2,4)",1);
									PrintMini(4,22,"et C(-3,-2,0). A, B et C ",1);
									PrintMini(4,29,"forment un plan s'ils ne",1);
									PrintMini(4,38,"pas alignes, donc si AB et AC",1);
									ML_line(85,36,94,36,ML_BLACK);
									ML_line(92,35,92,38,ML_BLACK);
									ML_line(109,36,118,36,ML_BLACK);
									ML_line(116,35,116,38,ML_BLACK);
									PrintMini(4,46,"ne sont pas colineaires",1);
									break;
								
								case 3:
									PrintMini(4,16,"AB(3,2,4) et AC(-3,-2,0) :",1);
									ML_line(4,14,12,14,ML_BLACK);
									ML_line(10,13,10,16,ML_BLACK);
									ML_line(52,14,61,14,ML_BLACK);
									ML_line(59,13,59,16,ML_BLACK);
									PrintMini(4,24,"Ces vecteurs ne sont pas",1);
									PrintMini(4,32,"colineaires, donc les points",1);
									PrintMini(4,40,"A, B et C ne sont pas alignes",1);
									PrintMini(4,48,"et forment un plan (ABC)",1);
									break;
								
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour trouver l'equation",1);
									PrintMini(4,22,"parametrique d'une droite",1);
									PrintMini(4,30,"ou d'un plan, il faut se",1);
									PrintMini(4,38,"referer a la formule enoncee",1);
									PrintMini(4,46,"dans le cours",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : la droite D passe",1);
									PrintMini(4,22,"par A(1,2,3) et a pour vecteur ",1);
									PrintMini(4,31,"directeur u(-1,2,1), son",1);
									ML_line(44,29,48,29,ML_BLACK);
									ML_line(46,28,46,31,ML_BLACK);
									PrintMini(4,39,"equation est : x = 1-t",1);
									PrintMini(4,47,"y = 2+2t et z = 3+t",1);
									break;
									
								case 3:
									PrintMini(4,14,"Le plan passant par A(1,2,3)",1);
									PrintMini(4,22,"et de vecteurs directeurs :",1);
									PrintMini(4,31,"u(1,0,1) et v(1,2,5) a pour",1);
									ML_line(4,29,8,29,ML_BLACK);
									ML_line(6,28,6,31,ML_BLACK);
									ML_line(48,29,52,29,ML_BLACK);
									ML_line(50,28,50,31,ML_BLACK);
									PrintMini(4,39,"equation : x = 1+t+t'",1);
									PrintMini(4,47,"y = 2+2t' et z = 3+t+5t'",1);
									break;
								
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Deux droites sont coplanaires",1);
									PrintMini(4,22,"si elles sont secantes, ",1);
									PrintMini(4,30,"strictement paralleles ou ",1);
									PrintMini(4,38,"confondues.",1);
									break;
									
								case 2:
									PrintMini(4,14,"Pour demontrer que deux",1);
									PrintMini(4,22,"droites (dont on connait les",1);
									PrintMini(4,30,"equations parametriques) sont",1);
									PrintMini(4,38,"secantes , il faut poser un ",1);
									PrintMini(4,46,"systeme et le resoudre",1);
									break;
								
								case 3:
									PrintMini(4,14,"Exemple : les droites d et d'",1);
									PrintMini(4,22,"ont pour equation (x,y,z) et ",1);
									PrintMini(4,30,"(x',y',z'), il faut poser x = x'",1);
									PrintMini(4,38,"y = y' et z = z', le resoudre",1);
									PrintMini(4,46,"et trouver le point d'inter.",1);
									break;
								
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 4:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Deux plans sont paralleles",1);
									PrintMini(4,22,"s'ils n'ont aucun points en",1);
									PrintMini(4,30,"commun ou si les deux plans",1);
									PrintMini(4,38,"sont confondus, ils sont",1);
									PrintMini(4,46,"secants sinon",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Les plans A et B",1);
									PrintMini(4,22,"sont respectivement defini par",1);
									PrintMini(4,30,"x+2y-z+3=0 et -2x-4y+2z-1=0",1);
									PrintMini(4,38,"Leur vecteur normaux sont :",1);
									PrintMini(4,47,"u(1,2,-1) et v(-2,-4,2)",1);
									ML_line(4,45,8,45,ML_BLACK);
									ML_line(6,44,6,47,ML_BLACK);
									ML_line(52,45,56,45,ML_BLACK);
									ML_line(54,44,54,47,ML_BLACK);
									break;
									
								case 3:
									PrintMini(4,14,"Les deux vecteurs sont",1);
									PrintMini(4,22,"colineaires (avec  un coeff.",1);
									PrintMini(4,30,"de -2), donc les deux plans",1);
									PrintMini(4,38,"sont paralleles",1);
									break;
								
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 5:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Une droite et un plan sont",1);
									PrintMini(4,22,"paralleles s'ils n'ont pas de",1);
									PrintMini(4,30,"points en commun ou si",1);
									PrintMini(4,38,"la droite est dans le plan,",1);
									PrintMini(4,46,"ils sont secants sinon",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Le plan P est",1);
									PrintMini(4,22,"defini par 2x - y + z + 2 = 0",1);
									PrintMini(4,30,"et la droite D par :",1);
									PrintMini(4,38,"x = 1 - 3t, y = 1 - 5t et ",1);
									PrintMini(4,46,"z = t (t dans |R)",1);
									break;
								
								case 3:
									PrintMini(4,14,"Le vecteur normal de P est :",1);
									PrintMini(4,23,"n(2,-1,1)",1);
									ML_line(4,21,8,21,ML_BLACK);
									ML_line(6,20,6,23,ML_BLACK);
									PrintMini(4,31,"Le vecteur directeur de D ",1);
									PrintMini(4,40,"est : u(-3,-5,1)",1);
									ML_line(27,38,31,38,ML_BLACK);
									ML_line(29,37,29,40,ML_BLACK);
									break;
								
								case 4:
									PrintMini(4,16,"u.n = -3*2 -5*(-1) + 1 = 0",1);
									ML_line(4,14,8,14,ML_BLACK);
									ML_line(6,13,6,16,ML_BLACK);
									ML_line(12,14,17,14,ML_BLACK);
									ML_line(15,13,15,16,ML_BLACK);
									PrintMini(4,24,"ainsi ces vecteurs sont",1);
									PrintMini(4,32,"orthogonaux, d'ou P et D",1);
									PrintMini(4,40,"sont paralleles",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 6:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Une droite et un plan sont",1);
									PrintMini(4,22,"secants et possede un point ",1);
									PrintMini(4,30,"d'intersection s'ils ne sont ",1);
									PrintMini(4,38,"pas paralleles",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Le plan P est",1);
									PrintMini(4,22,"defini par 2x - y + z + 2 = 0",1);
									PrintMini(4,30,"et la droite D est par :",1);
									PrintMini(4,38,"x = 2t + 1, y = 1 - t et ",1);
									PrintMini(4,46,"z = t (t dans |R)",1);
									break;
								
								case 3:
									PrintMini(4,14,"Le point d'intersection de P",1);
									PrintMini(4,22,"correspond a :",1);
									PrintMini(4,30,"2(2t+1) - (1-t) + t + 2 = 0",1);
									PrintMini(4,38,"En developpant on trouve :",1);
									PrintMini(4,46,"t = -(1/2)",1);
									break;
								
								case 4:
									PrintMini(4,14,"En remplacant t dans",1);
									PrintMini(4,22,"l'equation de D, on obtient :",1);
									PrintMini(4,30,"x = 0, y = 3/2 et z = -(1/2)",1);
									PrintMini(4,38,"Ainsi le point d'intersection",1);
									PrintMini(4,46,"de P et D est M(0,3/2,-1/2)",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 7:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour determiner les coord. du",1);
									PrintMini(4,22,"projete orthogonal d'un point",1);
									PrintMini(4,30,"A sur un plan, il faut savoir",1);
									PrintMini(4,38,"les coordonnees de A et",1);
									PrintMini(4,46,"l'equation du plan",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Le plan P est defini",1);
									PrintMini(4,22,"par 2x - y + z - 3 = 0 et M",1);
									PrintMini(4,30,"est le projete orthogonal de",1);
									PrintMini(4,38,"A(-5,-1,0) sur P, calculons",1);
									PrintMini(4,46,"les coordonnees de M",1);
									break;
									
								case 3:
									PrintMini(4,14,"Le vecteur normal du plan P",1);
									PrintMini(4,23,"est : n(2,-1,1). Si M(a,b,c) :",1);
									ML_line(27,21,31,21,ML_BLACK);
									ML_line(29,20,29,23,ML_BLACK);
									PrintMini(4,33,"alors AM(a+5,b+1,c). Ces deux",1);
									ML_line(29,30,39,30,ML_BLACK);
									ML_line(37,29,37,32,ML_BLACK);
									PrintMini(4,41,"vecteurs sont colineaires :",1);
									break;
									
								case 4:
									PrintMini(4,17,"D'ou AM = kn avec k un reel",1);
									ML_line(23,14,33,14,ML_BLACK);
									ML_line(31,13,31,16,ML_BLACK);
									ML_line(49,15,53,15,ML_BLACK);
									ML_line(51,14,51,17,ML_BLACK);
									PrintMini(4,25,"Ainsi a+5=2k, b+1=-k et c=k",1);
									PrintMini(4,33,"Donc a=2k-5, b=-k-1 et c=k",1);
									PrintMini(4,41,"On a 2(2k-5)-(-k-1)+k-3=0",1);
									break;
								
								case 5:
									PrintMini(4,14,"On trouve 6k = 12, donc k = 2",1);
									PrintMini(4,22,"D'ou a = -1, b = -3 et c = 2",1);
									PrintMini(4,30,"Ainsi le projete orthogonal du",1);
									PrintMini(4,38,"point A sur P est M(-1,-3,2)",1);
									break;
								
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 8:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour determiner une figure",1);
									PrintMini(4,22,"dans l'espace, il faut",1);
									PrintMini(4,30,"generalement calculer la",1);
									PrintMini(4,38,"distance separant les points",1);
									PrintMini(4,46,"qui la compose, et conclure",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Si dans l'espace on ",1);
									PrintMini(4,22,"a des points distincts A, B et",1);
									PrintMini(4,30,"C tel que AB = AC = BC, alors",1);
									PrintMini(4,38,"cela correspond a un triangle",1);
									PrintMini(4,46,"equilateral",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 9:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour tracer la section d'une",1);
									PrintMini(4,22,"figure, il faut dessiner un ",1);
									PrintMini(4,30,"plan en modelisant la section ",1);
									PrintMini(4,38,"de chaque face de la figure",1);
									break;
									
								case 2:
									PrintMini(4,14,"Techniques :",1);
									PrintMini(4,22,"- Relier les points presents",1);
									PrintMini(4,30,"sur une meme face",1);
									PrintMini(4,38,"- Prolonger les droites",1);
									PrintMini(4,46,"- Reporter si deux plans //",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(10,6,"Geometrie : quest.",1);
		
				question();
				
				fleche = 1;
				case_question_geometrie(milieu);
				case_question(choix,milieu);
				affichage_question_geometrie(choix);	
				fleche_question(milieu,8);
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_geometrie(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	if(milieu == 2)PrintMini(14,26,"Points",0);
	if(milieu > 1 && milieu < 4)PrintMini(13,62 - 12*milieu, "Param.", 0);
	if(milieu > 1 && milieu < 5)PrintMini(12,74 - 12*milieu, "Droites", 0);
	if(milieu > 2 && milieu < 6)PrintMini(16,86 - 12*milieu, "Plans", 0);
	if(milieu > 3 && milieu < 7)PrintMini(20,98 - 12*milieu, "D/P", 0);
	if(milieu > 4 && milieu < 8)PrintMini(14,110 - 12*milieu, "Inter.", 0);
	if(milieu > 5 && milieu < 9)PrintMini(14,122 - 12*milieu, "Coord.", 0);
	if(milieu > 6 && milieu < 10)PrintMini(14,134 - 12*milieu, "Figure", 0);
	if(milieu == 8)PrintMini(13,146 - 12*milieu, "Section", 0);
}

void affichage_question_geometrie(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Montrer que",0);
			PrintMini(54,32,"trois points",0);
			PrintMini(54,38,"forment un",0);
			PrintMini(54,44,"plan",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"une equation",0);
			PrintMini(54,38,"parametrique",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Trouver la",0);
			PrintMini(54,32,"relation qui",0);
			PrintMini(54,38,"existe entre",0);
			PrintMini(54,44,"deux droites",0);
			break;
	
		case 4 :
			PrintMini(54,26,"Trouver la",0);
			PrintMini(54,32,"relation qui",0);
			PrintMini(54,38,"existe entre",0);
			PrintMini(54,44,"deux plans",0);
			break;
			
		case 5 :
			PrintMini(54,26,"Trouver la",0);
			PrintMini(54,32,"relation qui",0);
			PrintMini(54,38,"existe entre",0);
			PrintMini(54,44,"une droite",0);
			PrintMini(54,50,"et un plan",1);
			break;
			
		case 6 :
			PrintMini(54,26,"Trouver le",0);
			PrintMini(54,32,"point",0);
			PrintMini(54,38,"d'intersect.",1);
			PrintMini(54,44,"d'une droite",0);
			PrintMini(54,50,"et d'un plan",0);
			break;
			
		case 7 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"les coord.",0);
			PrintMini(54,38,"du projete",0);
			PrintMini(54,44,"orthogonal",0);
			PrintMini(54,50,"d'un point",0);
			break;
			
		case 8 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"le type",0);
			PrintMini(54,38,"d'une figure",0);
			break;
			
		case 9 :
			PrintMini(54,26,"Tracer la",0);
			PrintMini(54,32,"section",0);
			PrintMini(54,38,"d'une figure",0);
			break;
	}
	
}