#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void proba()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	
	
	PrintXY(32,6,"Probabilite",1);	
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				proba_cours();
	
			if(choix == 2)
				proba_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(32,6,"Probabilite",1);	
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	

	}

	
}

void proba_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(6,1);
	
	PrintXY(24,6,"Proba : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 6  && position == 1)
		{
			choix += 1;
			choix_cours(choix,6);
			choix_cours(choix-1,6);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,6);
			choix_cours(choix+1,6);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,6);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,6);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(46,34,"Definition",0);
						break;
					case 2:
						PrintMini(47,34,"Formules",0);
						break;
					case 3:
						PrintMini(26,34,"Probabilites totales",0);
						break;
					case 4:
						PrintMini(22,34,"Evenement independant",0);
						break;
					case 5:
						PrintMini(39,34,"loi binomiale",0);
						break;
					case 6:
						PrintMini(23,34,"Coefficients binomiaux",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 1;		//Nombre de pages predominant
			
			switch(choix)
			{
				case 1:
					PrintMini(46,4,"Definition",0);
					break;
				case 2:
					pages = 4;
					PrintMini(47,4,"Formules",0);
					break;
				case 3:
					pages = 2;
					PrintMini(26,4,"Probabilites totales",0);
					break;
				case 4:
					PrintMini(22,4,"Evenement independant",0);
					break;
				case 5:
					pages = 4;
					PrintMini(39,4,"loi binomiale",0);
					break;
				case 6:
					pages = 2;
					PrintMini(23,4,"Coefficients binomiaux",0);
					break;
			}
			
			if(choix == 1 || choix == 2 || choix == 5)
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);	//Affichage des deux bandes noires
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,11+116*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 16 ; i <52 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Soit un univers associe a une",1);
									PrintMini(4,26,"epreuve aleatoire A tel que",1);	
									PrintMini(4,34,"P(A)   0. P(A) designe la",1);
									different(21,34);
									PrintMini(4,42,"probabilite que A se passe",1);
									break;
								
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Formules de base :",1);
									PrintMini(4,28,"P(AUB) = P(A) + P(B) - P(A B)",1);
									inter(101,28);
									PrintMini(4,38,"P(A) = 1 - P(A)",1);
									ML_line(11,36,14,36,ML_BLACK);
									break;
								
								case 2:
									PrintMini(4,16,"On appelle probabilite de B ",1);
									PrintMini(4,24,"sachant A le reel :",1);
									PrintMini(4,38,"P (B) =",1);
									PrintMini(8,40,"A",1);
									ML_line(32,40,54,40,ML_BLACK);
									PrintMini(33,33,"P(A B)",1);
									inter(44,33);
									PrintMini(37,43,"P(A)",1);
									PrintMini(60,38,"(entre 0 et 1)",1);
									break;
									
								case 3:
									PrintMini(4,18,"P (A) = 1",1);
									PrintMini(8,20,"A",1);
									PrintMini(4,28,"P(A B) = P (B) * P(A)",1);
									PrintMini(42,30,"A",1);
									inter(15,28);
									PrintMini(4,38,"P (B) = 1 - P (B)",1);
									PrintMini(8,40,"A",1);
									PrintMini(54,40,"A",1);
									ML_line(15,36,18,36,ML_BLACK);
									break;
								
								case 4:
									PrintMini(4,18,"Formule de BAYES :",1);
									PrintMini(4,35,"P (A) =",1);
									PrintMini(8,37,"B",1);
									ML_line(32,37,114,37,ML_BLACK);
									PrintMini(52,29,"P (B)*P(A)",1);
									PrintMini(56,31,"A",1);
									PrintMini(34,41,"P (B)*P(A)+P (B)*P(A)",1);
									PrintMini(38,43,"A",1);
									PrintMini(80,43,"A",1);
									ML_line(80,41,83,41,ML_BLACK);
									ML_line(107,39,110,39,ML_BLACK);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Systeme complet d'evenement :",1);
									PrintMini(4,26,"Ensemble d'evenement deux",1);
									PrintMini(4,34,"a deux incompatibles dont la",1);
									PrintMini(4,42,"reunion forme l'univers",1);
									break;
								
								case 2:
									PrintMini(4,16,"( A  , ... , A  ) une partition ",1);
									PrintMini(15,18,"1",1);
									PrintMini(58,18,"n",1);
									PrintMini(4,24,"de l'univers :",1);
									somme(34,38);
									PrintMini(36,32,"n",1);
									PrintMini(38,47,"i",1);
									PrintMini(10,40,"P(B) =    P  ",1);
									PrintMini(59,40,"(B) * P(Ai)",1);
									PrintMini(52,42,"Ai",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"A et B sont independants si",1);
									PrintMini(4,26,"P(A B) = P(A) * P(B)",1);
									inter(15,26);		
									PrintMini(4,34,"Si c'est le cas, alors de meme",1);
									PrintMini(4,42,"pour A et B , A et B , A et B",1);
									ML_line(45,40,48,40,ML_BLACK);
									ML_line(60,40,63,40,ML_BLACK);
									ML_line(95,40,98,40,ML_BLACK);
									ML_line(115,40,118,40,ML_BLACK);
									break;
									
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Epreuve de Bernouilli :",1);
									PrintMini(4,26,"Epreuve alliant deux issues",1);
									PrintMini(4,34,"succes (p) et echec (1-p)",1);
									break;
									
								case 2:
									PrintMini(4,18,"Schema de Bernouilli :",1);
									PrintMini(4,26,"repetition n fois d'une meme",1);
									PrintMini(4,34,"epreuve de Bernouilli : loi",1);
									PrintMini(4,42,"binomiale (variables : n et p)",1);
									break;
								
								case 3:
									PrintMini(4,18,"Les valeurs prises par X sont",1);
									PrintMini(4,26,"(0,1,...,n). On a :",1);
									parenthese(36,34,9);
									PrintMini(4,40,"P(X=k) =     * p  * (1-p)",1);
									PrintMini(41,36,"n",1);
									PrintMini(41,44,"k",1);
									PrintMini(69,38,"k",1);
									PrintMini(105,38,"n-k",1);
									break;
								
								case 4:
									PrintMini(4,18,"Loi binomiale :",1);
									PrintMini(4,26,"Esperance : E(X) = np",1);
									PrintMini(4,34,"Variance : V(X) = np(1-p)",1);
									PrintMini(4,43,"Ecart-type :  np(1-p)",1);
									racine_carre(55,41,30);
									break;
									
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 6:
							switch(position_cours)
							{
								case 1:
									parenthese(4,16,9);
									PrintMini(9,18,"n",1);
									PrintMini(9,26,"0",1);
									PrintMini(20,22,"=",1);
									parenthese(26,16,9);
									PrintMini(31,18,"n",1);
									PrintMini(31,26,"n",1);
									PrintMini(42,22,"= 1",1);
									parenthese(4,34,9);
									PrintMini(9,36,"n",1);
									PrintMini(9,44,"1",1);
									PrintMini(20,40,"=",1);
									parenthese(26,34,17);
									PrintMini(35,36,"n",1);
									PrintMini(31,44,"n-1",1);
									PrintMini(50,40,"= n",1);
									break;
								
								case 2:
									parenthese(4,16,9);
									PrintMini(9,18,"n",1);
									PrintMini(9,26,"k",1);
									PrintMini(20,22,"=",1);
									parenthese(26,16,17);
									PrintMini(35,18,"n",1);
									PrintMini(31,26,"n-k",1);
									parenthese(4,34,9);
									PrintMini(9,36,"n",1);
									PrintMini(9,44,"k",1);
									PrintMini(20,40,"=",1);
									parenthese(26,34,17);
									PrintMini(31,36,"n-1",1);
									PrintMini(35,44,"k",1);
									PrintMini(50,40,"+",1);
									parenthese(56,34,17);
									PrintMini(61,36,"n-1",1);
									PrintMini(61,44,"k-1",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(6,choix);
				PrintXY(24,6,"Proba : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void proba_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0, fleche = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour, fleche : si c'est egal a 1 : regarde s'il faut afficher ou non une fleche
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(10,6,"Proba. : questions",1);
	
	question();
	
	case_question_proba(2);
	case_question(1,2);

	fleche_question(milieu,3);
	
	affichage_question_proba(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 4 && retour == 0)
		{
			choix ++;
			
			if(choix > (milieu + 1))
			{	
				milieu ++;
				fleche = 1;		
				case_question_proba(milieu);
				
			}
			else
				case_question(choix - 1 , milieu);
			
			case_question(choix,milieu);	
			affichage_question_proba(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			if(choix < (milieu - 1))
			{	
				milieu --;
				fleche = 1;
				case_question_proba(milieu);
				case_question(choix,milieu);
			}
			else
			{
				case_question(choix + 1 , milieu);
				case_question(choix , milieu);
			}
	
			affichage_question_proba(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(fleche)	//Affichage des fleches pour que l'utilisateur sache s'il y a des choix plus bas ou plus haut
		{
			fleche_question(milieu,3);
			fleche = 0;	
		}

		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			pages = 4;
			
			switch(choix)
			{
				case 1:
					pages = 6;
					PrintMini(39,4,"Probabilite simple",1);
					break;
				case 2:
					pages = 5;
					PrintMini(39,4,"Probabilite complexe",1);
					break;
				case 3:
					PrintMini(39,4,"Bernouilli",1);
					break;
				case 4:
					PrintMini(39,4,"Inequation et n",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <53 ; i++)ML_line(2,i,125,i,ML_WHITE);
					ML_line(2,53,100,53,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Il faut generalement traduire",1);
									PrintMini(4,22,"l'enonce en formule de",1);
									PrintMini(4,30,"probabilite pour trouver la",1);
									PrintMini(4,38,"valeur a determiner (un arbre",1);
									PrintMini(4,46,"de probabilite peut aider)",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Zoe se rend a son",1);
									PrintMini(4,22,"travail a pied ou en voiture,",1);
									PrintMini(4,30,"il pleut un jour sur quatre.",1);
									PrintMini(4,38,"Quand il pleut, elle s'y rend",1);
									PrintMini(4,46,"en voiture dans 80% des cas.",1);
									break;
								
								case 3:
									PrintMini(4,14,"S'il ne pleut pas, elle s'y ",1);
									PrintMini(4,22,"rend a pied avec une ",1);
									PrintMini(4,30,"probabilite egale a 0,6.",1);
									PrintMini(4,38,"Zoe utilise-t-elle la voiture",1);
									PrintMini(4,46,"un jour sur deux ?",1);
									break;
									
								case 4:
									PrintMini(4,14,"On pose les evenements :",1);
									PrintMini(4,22,"T : \"il pleut\"",1);
									PrintMini(4,30,"V : \"elle utilise la voiture\"",1);
									PrintMini(4,38,"En traduisant l'enonce, on a",1);
									PrintMini(4,46,"P(T)=1/4, P (V)=0,8 et P (V)=0,6",1);
									PrintMini(45,48,"T",1);
									PrintMini(94,48,"T",1);
									ML_line(94,46,97,46,ML_BLACK);	
									ML_line(101,44,104,44,ML_BLACK);								
									break;
									
								case 5:
									PrintMini(4,14,"On cherche P(V) :",1);
									PrintMini(4,22,"{T,T} est un systeme complet",1);
									ML_line(15,20,18,20,ML_BLACK);
									PrintMini(4,30,"d'evenement, donc d'apres",1);
									PrintMini(4,38,"la formule des proba. totales :",1);
									PrintMini(4,46,"P(V) = P(T)*P (V) + P(T)*P (V)",1);		
									PrintMini(54,48,"T",1);
									PrintMini(104 ,48,"T",1);	
									ML_line(87,44,90,44,ML_BLACK);
									ML_line(104,46,107,46,ML_BLACK);
									break;
								
								case 6:
									PrintMini(4,14,"P(v)=(1/4)*0,8+(1-1/4)*(1-0,6)",1);
									PrintMini(4,22,"D'ou P(V) = 0,5",1);
									PrintMini(4,30,"Ainsi l'affirmation est vraie",1);
									PrintMini(4,38,"Zoe utilise la voiture un jour",1);
									PrintMini(4,46,"sur deux",1);
									break;
								
								case 7:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Il faut generalement traduire",1);
									PrintMini(4,22,"l'enonce en formule de",1);
									PrintMini(4,30,"probabilite pour trouver la",1);
									PrintMini(4,38,"valeur a determiner (un arbre",1);
									PrintMini(4,46,"de probabilite peut aider)",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Dans une assoc.",1);
									PrintMini(4,22,"sportive, un quart des femmes",1);
									PrintMini(4,30,"et un tiers des hommes",1);
									PrintMini(4,38,"adherent a la section tennis.",1);
									PrintMini(4,46,"(30% des membres y adherent)",1);
									break;
									
								case 3:
									PrintMini(4,14,"On choisit au hasard un",1);
									PrintMini(4,22,"membre de cette association",1);
									PrintMini(4,30,"F : \"C'est une femme\"",1);
									PrintMini(4,38,"T : \"Il adhere a la section",1);
									PrintMini(4,46,"tennis\"",1);
									break;
									
								case 4:
									PrintMini(4,14,"Calculons P(F) :",1);
									PrintMini(4,22,"On pose P(F)=p, donc P(F)=1-p",1);
									ML_line(94,20,97,20,ML_BLACK);
									PrintMini(4,30,"{F,F} est un systeme complet",1);
									ML_line(15,28,18,28,ML_BLACK);
									PrintMini(4,38,"d'evenement, donc :",1);
									PrintMini(4,46,"P(T) = P(F)*P (T) + P(F)*P (T)",1);		
									PrintMini(54,48,"F",1);
									PrintMini(104 ,48,"F",1);	
									ML_line(87,44,90,44,ML_BLACK);
									ML_line(104,46,107,46,ML_BLACK);
									break;
								
								case 5:
									PrintMini(4,14,"Or P(T) = 3/10, P (T) = 1/4 ",1);
									PrintMini(70,16,"F",1);
									PrintMini(4,22,"et P (T)=1/3",1);
									PrintMini(20,24,"F",1);	
									ML_line(20,22,23,22,ML_BLACK);
									PrintMini(4,30,"Ainsi 3/10 = (1/4)p + (1/3)(1-p)",1);
									PrintMini(4,38,"On trouve donc p = 2/5",1);
									PrintMini(4,46,"Donc P(F) = 2/5",1);
									break;
								
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Une epreuve de Bernouilli",1);
									PrintMini(4,22,"allie deux issues : succes",1);
									PrintMini(4,30,"et echec, et a pour variables",1);
									PrintMini(4,38,"p (la probabilite du succes)",1);
									PrintMini(4,46,"et n (le nombre de repetition)",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : On lance quatre",1);
									PrintMini(4,22,"fois de suite un de, calculons",1);
									PrintMini(4,30,"la probabilite d'obtenir trois",1);
									PrintMini(4,38,"fois le chiffre 6. On a :",1);
									PrintMini(4,46,"p = 1/6 et n = 4",1);
									break;
								
								case 3:
									PrintMini(4,14,"On cherche a calculer P(X=3)",1);
									PrintMini(4,26,"P(X=3) =     * (1/6)  * (5/6)",1);
									parenthese(37,20,7);
									PrintMini(41,22,"4",1);
									PrintMini(41,30,"3",1);
									PrintMini(82,24,"3",1);
									PrintMini(4,38,"P(X=3) = BinominalPD(3,4,1/6)",1);
									PrintMini(4,46,"D'ou P(X=3) = 0,0154",1);
									break;
									
								case 4:
									PrintMini(4,14,"Pour trouver BinominalPD() :",1);
									PrintMini(4,22,"(de parametres k, n et p)",1);
									PrintMini(4,30,"[OPTN], [STAT], [DIST], [BINM]",1);
									PrintMini(4,38,"et [BPD] ([BDP] calcule P(X=k)",1);
									PrintMini(4,46,"et [BCD] calcule P(X",1);
									signe_inferieur_egal(82,46);
									PrintMini(89,46,"k))",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 4:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour determiner un nombre",1);
									PrintMini(4,22,"entier minimal n pour que la",1);
									PrintMini(4,30,"probabilite atteigne un reel,",1);
									PrintMini(4,38,"il faut resoudre l'inequation",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : p  = 1 - (7/10)",1);
									PrintMini(49,17,"n",1);
									PrintMini(104,13,"n",1);
									PrintMini(4,23,"Determinons l'entier minimal",1);
									PrintMini(4,31,"n pour que p",1);
									PrintMini(54,33,"n",1);
									signe_superieur_egal(62,31);
									PrintMini(71,31,"0,99",1);
									break;
								
								case 3:
									PrintMini(4,14,"p",1);
									PrintMini(8,16,"n",1);
									signe_superieur_egal(16,14);
									PrintMini(25,14,"0,99",1);
									equivaut(4,22);
									PrintMini(16,22,"1 - (7/10)",1);
									PrintMini(54,20,"n",1);
									signe_superieur_egal(62,22);
									PrintMini(71,22,"0,99",1);
									equivaut(4,30);
									PrintMini(16,30,"(7/10)",1);
									PrintMini(38,28,"n",1);
									signe_inferieur_egal(46,30);
									PrintMini(55,30,"0,01",1);
									equivaut(4,38);
									PrintMini(16,38,"ln[(7/10)",1);
									PrintMini(50,36,"n",1);
									PrintMini(55,38,"]",1);
									signe_inferieur_egal(61,38);
									PrintMini(70,38,"ln(0,01)",1);
									equivaut(4,46);
									PrintMini(16,46,"n * ln(7/10)",1);
									signe_inferieur_egal(69,46);
									PrintMini(78,46,"ln(0,01)",1);
									break;
									
								case 4:
									equivaut(4,14);
									PrintMini(16,14,"n",1);
									signe_superieur_egal(24,14);
									PrintMini(33,14,"[ln(0,01)]/[ln(7/10)]",1);
									PrintMini(4,22,"le signe change car ln(7/10)<0",1);
									equivaut(4,30);
									PrintMini(16,30,"n",1);
									signe_superieur_egal(24,30);
									PrintMini(32,30,"12,9",1);
									PrintMini(4,38,"Ainsi n = 13",1);
									break;
									
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(10,6,"Proba. : questions",1);
		
				question();
				
				case_question_proba(milieu);
				case_question(choix,milieu);
				affichage_question_proba(choix);	
				fleche_question(milieu,3);
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_proba(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	if(milieu == 2)PrintMini(12,26,"Proba 1",0);
	if(milieu > 1 && milieu < 4)PrintMini(12,62 - 12*milieu, "Proba 2", 0);
	if(milieu > 1 && milieu < 5)PrintMini(7,74 - 12*milieu, "Bernouilli", 0);
	if(milieu > 2 && milieu < 6)PrintMini(9,86 - 12*milieu, "Calcul n", 0);
}

void affichage_question_proba(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Calculer une",0);
			PrintMini(54,32,"probabilite",0);
			PrintMini(54,38,"simple",1);
			break;
		
		case 2 :
			PrintMini(54,26,"Calculer une",0);
			PrintMini(54,32,"probabilite",0);
			PrintMini(54,38,"compliquee",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Utiliser une",0);
			PrintMini(54,32,"experience",0);
			PrintMini(54,38,"de Bernouilli",0);
			break;
	
		case 4 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"l'entier n",0);
			PrintMini(54,38,"tel que",0);
			PrintMini(55,45,"p  > a",0);
			PrintMini(59,47,"n",1);
			break;
	}
}